﻿using System;
using System.Net;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;

namespace PollyCircuitBreakerRemote.Controllers
{
    [Produces("application/json")]
    [Route("[controller]")]
    public class InventoryController : Controller
    {
        static int _requestCount = 0;

        [HttpGet("{catalogId}")]
        public async Task<IActionResult> Get(int catalogId)
        {
            _requestCount++;
            Console.WriteLine($"RequestCount:{_requestCount}");
            await Task.Delay(100); // simulate some processing delay

            int numberAvailable = catalogId + 100;

            if (_requestCount % 4 == 0) // only one out four requests will succeed
            {
                Console.WriteLine(" - returning OK");
                return Ok(numberAvailable);
            }

            Console.WriteLine(" - returning 500");
            return StatusCode((int) HttpStatusCode.InternalServerError, "Something went wrong");
        }
    }
}
