﻿using System;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Builder;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.DependencyInjection;

namespace PollyCircuitBreakerRemote
{
    public class Startup
    {
        private bool _firstRequest = true;

        public Startup(IConfiguration configuration)
        {
            Configuration = configuration;
        }

        public IConfiguration Configuration { get; }

        // This method gets called by the runtime. Use this method to add services to the container.
        public void ConfigureServices(IServiceCollection services)
        {
            services.AddMvc();
        }

        // This method gets called by the runtime. Use this method to configure the HTTP request pipeline.
        public void Configure(IApplicationBuilder app, IHostingEnvironment env)
        {
            app.Use(PrintRequestUrl);
            if (env.IsDevelopment())
            {
                app.UseDeveloperExceptionPage();
            }

            app.UseMvc();
        }

        private async Task PrintRequestUrl(HttpContext httpContext, Func<Task> next)
        {
            if (_firstRequest)
            {
                Console.WriteLine("\n");
                _firstRequest = false;
            }

            Console.WriteLine($"Incoming Request: www.remoteservice.com{httpContext.Request.Path}");
            await next.Invoke();
        }
    }
}
